"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var core_1 = require("@angular/core");
var event_manager_1 = require("@angular/platform-browser/src/dom/events/event_manager");
var MultiEventPlugin = (function (_super) {
    __extends(MultiEventPlugin, _super);
    function MultiEventPlugin() {
        _super.apply(this, arguments);
    }
    MultiEventPlugin.prototype.supports = function (eventName) {
        return eventName.indexOf('multi.') === 0;
    };
    MultiEventPlugin.prototype.addEventListener = function (element, eventName, handler) {
        var _this = this;
        var eventNames = eventName.slice(6).split(',');
        var eventListeners = eventNames.map(function (x) {
            return _this.manager.addEventListener(element, x, handler);
        });
        return function () {
            eventListeners.forEach(function (x) { return x(); });
        };
    };
    MultiEventPlugin.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    MultiEventPlugin.ctorParameters = function () { return []; };
    return MultiEventPlugin;
}(event_manager_1.EventManagerPlugin));
exports.MultiEventPlugin = MultiEventPlugin;
