"use strict";
var core_1 = require("@angular/core");
var ObserveEventDirective = (function () {
    function ObserveEventDirective(elm, renderer, zone) {
        this.elm = elm;
        this.renderer = renderer;
        this.zone = zone;
        this.listeners = [];
    }
    Object.defineProperty(ObserveEventDirective.prototype, "events", {
        set: function (e) {
            var _this = this;
            this.listeners.forEach(function (x) { return x(); });
            var events = (typeof (e) === 'string')
                ? [e]
                : e;
            this.zone.runOutsideAngular(function () {
                _this.listeners = events.map(function (x) {
                    return _this.renderer.listen(_this.elm.nativeElement, x, function ($event) { return _this.fireEvent($event); });
                });
            });
        },
        enumerable: true,
        configurable: true
    });
    ObserveEventDirective.prototype.fireEvent = function ($event) {
        if (!this.observe)
            return;
        this.observe.next($event);
    };
    ObserveEventDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: '[ev-observe]'
                },] },
    ];
    /** @nocollapse */
    ObserveEventDirective.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
        { type: core_1.Renderer, },
        { type: core_1.NgZone, },
    ]; };
    ObserveEventDirective.propDecorators = {
        'observe': [{ type: core_1.Input, args: ['ev-observe',] },],
        'events': [{ type: core_1.Input, args: ['ev-events',] },],
    };
    return ObserveEventDirective;
}());
exports.ObserveEventDirective = ObserveEventDirective;
