"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var core_1 = require("@angular/core");
var event_manager_1 = require("@angular/platform-browser/src/dom/events/event_manager");
var Subject_1 = require("rxjs/Subject");
var ObserveEventPlugin = (function (_super) {
    __extends(ObserveEventPlugin, _super);
    function ObserveEventPlugin() {
        _super.apply(this, arguments);
    }
    ObserveEventPlugin.prototype.supports = function (eventName) {
        return eventName.indexOf('observe.') === 0;
    };
    ObserveEventPlugin.prototype.addEventListener = function (element, eventName, handler) {
        var _this = this;
        return this.manager.getZone().runOutsideAngular(function () {
            var eventRest = eventName.slice(8).split('.');
            var fnParts = eventRest[0].split('-');
            var fnName = fnParts[0];
            var fnArg = (fnParts.length > 1) ? +fnParts[1] : undefined;
            var delegateEvent = eventRest.slice(1).join('.');
            var subject = new Subject_1.Subject();
            var observable = subject.asObservable();
            if (observable[fnName]) {
                observable = (fnArg !== undefined)
                    ? observable[fnName](fnArg)
                    : observable[fnName]();
            }
            else {
                console.error('The function "' + fnName + '" does not exist on Observable!');
                return function () { };
            }
            observable.subscribe(function (x) { return _this.manager.getZone().run(function () { return handler(x); }); });
            var listener = _this.manager.addEventListener(element, delegateEvent, function ($event) {
                subject.next($event);
            });
            return function () {
                listener();
                subject.complete();
            };
        });
    };
    ObserveEventPlugin.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    ObserveEventPlugin.ctorParameters = function () { return []; };
    return ObserveEventPlugin;
}(event_manager_1.EventManagerPlugin));
exports.ObserveEventPlugin = ObserveEventPlugin;
