"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var core_1 = require("@angular/core");
var event_manager_1 = require("@angular/platform-browser/src/dom/events/event_manager");
var TouchEventPlugin = (function (_super) {
    __extends(TouchEventPlugin, _super);
    function TouchEventPlugin() {
        _super.apply(this, arguments);
    }
    TouchEventPlugin.prototype.supports = function (eventName) {
        return eventName === 'down' || eventName === 'up';
    };
    TouchEventPlugin.prototype.addEventListener = function (element, eventName, handler) {
        var _this = this;
        var eventNames = (eventName === 'down')
            ? ['mousedown', 'touchstart', 'pointerdown']
            : ['mouseup', 'touchend', 'pointerup'];
        var eventListeners = eventNames.map(function (x) {
            return _this.manager.addEventListener(element, x, function (e) {
                e.preventDefault();
                handler(e);
            });
        });
        return function () {
            eventListeners.forEach(function (x) { return x(); });
        };
    };
    TouchEventPlugin.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    TouchEventPlugin.ctorParameters = function () { return []; };
    return TouchEventPlugin;
}(event_manager_1.EventManagerPlugin));
exports.TouchEventPlugin = TouchEventPlugin;
